#include "saAis.h"
#include "saAmf.h"
#include "saClm.h"


typedef int BaseType;

typedef struct {
	SaUint16T length;
	SaUint8T value[SA_MAX_NAME_LENGTH];
} StringStructure;

BaseType* generateBaseType(int * numberOfGenerated);

SaVersionT* generateSaVersionT(int * numberOfGenerated);
SaVersionT generateValidSaVersionT();
SaVersionT** generatePointerSaVersionT(int * numberOfGenerated);

SaDispatchFlagsT* generateSaDispatchFlagsT(int * numberOfGenerated);

SaSelectionObjectT* generateSaSelectionObjectT(int * numberOfGenerated);
SaSelectionObjectT** generatePointerSaSelectionObjectT(int * numberOfGenerated);

SaUint8T* generateSaUint8T(int * numberOfGenerated);

SaUint16T* generateSaUint16T(int * numberOfGenerated);

SaUint32T* generateSaUint32T(int * numberOfGenerated);

SaUint64T* generateSaUint64T(int * numberOfGenerated);

SaInt32T* generateSaInt32T(int * numberOfGenerated);

SaInt64T* generateSaInt64T(int * numberOfGenerated);

SaTimeT* generateSaTimeT(int * numberOfGenerated);

SaInvocationT* generateSaInvocationT(int * numberOfGenerated);

SaAisErrorT* generateSaAisErrorT(int * numberOfGenerated);

SaNameT* generateSaNameT(int * numberOfGenerated);
SaNameT generateValidSaNameT();
SaNameT** generatePointerSaNameT(int * numberOfGenerated);

StringStructure* generateStringStructure(int * numberOfGenerated);
StringStructure** generatePointerStringStructure(int * numberOfGenerated);

SaNtfIdentifierT* generateSaNtfIdentifierT(int * numberOfGenerated);

SaAmfHandleT* generateSaAmfHandleT(int * numberOfGenerated);
SaAmfHandleT generateValidSaAmfHandleT();
SaAmfHandleT** generatePointerSaAmfHandleT(int * numberOfGenerated);

SaAmfCallbacksT* generateSaAmfCallbacksT(int * numberOfGenerated);
SaAmfCallbacksT generateValidSaAmfCallbacksT();
SaAmfCallbacksT** generatePointerSaAmfCallbacksT(int * numberOfGenerated);

SaAmfHAStateT* generateSaAmfHAStateT(int * numberOfGenerated);
SaAmfHAStateT** generatePointerSaAmfHAStateT(int * numberOfGenerated);

SaAmfProtectionGroupMemberT* generateSaAmfProtectionGroupMemberT(int * numberOfGenerated);
SaAmfProtectionGroupMemberT generateValidSaAmfProtectionGroupMemberT();
SaAmfProtectionGroupMemberT** generatePointerSaAmfProtectionGroupMemberT(int * numberOfGenerated);

SaAmfProtectionGroupNotificationT* generateSaAmfProtectionGroupNotificationT(int * numberOfGenerated);
SaAmfProtectionGroupNotificationT generateValidSaAmfProtectionGroupNotificationT();
SaAmfProtectionGroupNotificationT** generatePointerSaAmfProtectionGroupNotificationT(int * numberOfGenerated);

SaAmfProtectionGroupNotificationBufferT* generateSaAmfProtectionGroupNotificationBufferT(int * numberOfGenerated);
SaAmfProtectionGroupNotificationBufferT** generatePointerSaAmfProtectionGroupNotificationBufferT(int * numberOfGenerated);

SaAmfRecommendedRecoveryT* generateSaAmfRecommendedRecoveryT(int * numberOfGenerated);

SaAmfHealthcheckKeyT* generateSaAmfHealthcheckKeyT(int * numberOfGenerated);
SaAmfHealthcheckKeyT** generatePointerSaAmfHealthcheckKeyT(int * numberOfGenerated);

SaAmfHealthcheckInvocationT* generateSaAmfHealthcheckInvocationT(int * numberOfGenerated);

SaAmfPmErrorsT* generateSaAmfPmErrorsT(int * numberOfGenerated);

SaAmfPmStopQualifierT* generateSaAmfPmStopQualifierT(int * numberOfGenerated);

SaClmCallbacksT* generateSaClmCallbacksT(int * numberOfGenerated);
SaClmCallbacksT generateValidSaClmCallbacksT();
SaClmCallbacksT** generatePointerSaClmCallbacksT(int * numberOfGenerated);

SaClmClusterChangesT* generateSaClmClusterChangesT(int * numberOfGenerated);

SaClmClusterNodeT* generateSaClmClusterNodeT(int * numberOfGenerated);
SaClmClusterNodeT generateValidSaClmClusterNodeT();
SaClmClusterNodeT** generatePointerSaClmClusterNodeT(int * numberOfGenerated);

SaClmClusterNotificationBufferT* generateSaClmClusterNotificationBufferT(int * numberOfGenerated);
SaClmClusterNotificationBufferT** generatePointerSaClmClusterNotificationBufferT(int * numberOfGenerated);

SaClmHandleT* generateSaClmHandleT(int * numberOfGenerated);
SaClmHandleT generateValidSaClmHandleT();
SaClmHandleT** generatePointerSaClmHandleT(int * numberOfGenerated);

SaClmNodeAddressFamilyT* generateSaClmNodeAddressFamilyT(int * numberOfGenerated);

SaClmNodeAddressT* generateSaClmNodeAddressT(int * numberOfGenerated);

SaClmNodeIdT* generateSaClmNodeIdT(int * numberOfGenerated);

